

// handler do obslugi grafiki w programie IHA
// by Pawel Biernacki



#include <stdlib.h>


extern int dokladnosc,dokbit;
extern int xekr,yekr;

struct punkt;

struct wektor
	{
	long x,y,z;
	wektor(long nx,long ny,long nz)
	 { x=nx << dokbit; y=ny << dokbit; z=nz << dokbit; }
	wektor(void) {}
	wektor(punkt &a,punkt &b);
	wektor operator *(long a)
	{ return wektor((x*a)>>dokbit,(y*a)>>dokbit,(z*a)>>dokbit); }
	};

struct punkt
	{
	long x,y,z;
	punkt(void) {}
	punkt(long nx,long ny,long nz)
	 { x=nx<<dokbit; y=ny<<dokbit; z=nz<<dokbit; }
	wektor operator -(punkt &b)
	 { return wektor(x-b.x,y-b.y,z-b.z); }
	void operator +=(wektor &t)
	 { x+=t.x; y+=t.y; z+=t.z; }
	void operator -=(wektor &t)
	 { x-=t.x; y-=t.y; z-=t.z; }
	};


extern wektor PA;
extern punkt P;

void obetnij_z_lewej(int &x1,int &y1,int &x2,int &y2)
{
 y1=(int)(y2+((long)(y1-y2)*(1+xekr+x2))/abs(x1-x2));
 x1=-xekr;
}


// funkcja przelicza kolumne wzoru dla zmienanego punktu
void obetnij_z_prawej(int &x1,int &y1,int &x2,int &y2)
{
 y1=(int)(y2+((long)(y1-y2)*(1+xekr-x2))/abs(x1-x2));
 x1=xekr+1;
}





// pierwszy parametr - punkt niewidoczny, drugi parametr - punkt widoczny

// funkcja zastepuje punkt N innym punktem - dodatkowo przelicza
// kolumne wzoru dla zmienanego punktu
punkt przeciecie(punkt &N,punkt &M,int &kolumna,int kierunek)
{
 long W;
 long s;
 wektor NM(N,M);
 punkt wynik;

 W=(PA.x*NM.y-NM.x*PA.y)>>dokbit;

 if (W)
  {
  wynik=M;
  s=(PA.x*(M.y-P.y)-(M.x-P.x)*PA.y)/W;

  if ((s>=0) && (s<=dokladnosc))
	{
	NM.x=(NM.x*s)>>dokbit;
	NM.y=(NM.y*s)>>dokbit;
	wynik-=NM;

	kierunek*=(int)(dokladnosc-s);
	kierunek>>=dokbit;

	kolumna+=kierunek;

	// przeliczenie kolumny wzoru
	}
  }
  else
  wynik=N;


 return wynik;
}


#define TEKBIT 0
// polowa wysokosci wzoru

#define wzor_wys_bit 4

// warunek - szerokosc wzoru*dokladnosc musi sie miescic w zakresie int

#define MUR_WYS 31
#define MUR_SZER 63
#define MUR_SZER_BIT 6


extern long WXN,WN,WXM,WM;
extern int YN,YM,XN,XM;
extern int szerokosc,PN,PM,wzor_wys_anim;
extern unsigned bufor_seg,bufor_off,murek_off,murek_seg;


int deltax,p,ygran,pomoc;
long par1,par2,ssy,a0,dzielnik,dzielnik0,WNszer;
unsigned sym,sys,PNbit;
int xm;
unsigned am,ym,ym2,y0m,y0s;
int znaksx;


extern "C" void podziel(void);

void paint_wall(void)
{
 deltax=abs(XM-XN);
 szerokosc=abs(PM-PN);

 if (XM<XN) znaksx=-1; else znaksx=1;

 par1=WXM-WXN; par2=WN-WM;

 PNbit=PN; // << TEKBIT

 xm=(unsigned)(XN);

 ssy=(YM-YN);

 podziel();
}





#define pot_wys_bit 5

#define POT_WYS 63
#define POT_SZER 31
#define POT_SZER_BIT 5



extern unsigned potwor_off,potwor_seg;

/*
void paint_monster(void)
{
 deltax=abs(XM-XN);
 szerokosc=abs(PM-PN);

 if (XM<XN) znaksx=-1; else znaksx=1;

 par1=WXM-WXN; par2=WN-WM;

 PNbit=PN; // << TEKBIT

 xm=(unsigned)(XN);

 ssy=(YM-YN);

 podziel();
}
*/

void paint_monster(void)
{
 int deltax,p,ygran1,ygran2,pomoc,obciete;
 long par1,par2,sy,a0,dzielnik,dzielnik0,WNszer;
 unsigned sym,sys,PNbit;
 int xm;
 unsigned am,ym,ym2,roznica,y0m,y0s;
 int znaksx=1;


 deltax=abs(XM-XN);
 szerokosc=abs(PM-PN);

 if (XM<XN) znaksx=-1;

 sy=(YM-YN); sy<<=8; sy/=deltax;

 sym=(unsigned)(sy); sys=(unsigned)(sy >> 16);

 par1=WXM-WXN; par2=WN-WM;


 PNbit=PN;

 xm=(unsigned)(XN);

 dzielnik0=par1+xm*par2;

 a0=xm*WN-WXN; a0*=szerokosc;

 WNszer=WN*szerokosc;

 y0m=0; y0s=0;

 for (p=0;p<=deltax;p++)
  {

  // y=YN+((sy*p)>>8);

  asm {  // ym=YN+(unsigned)(y0 >> 8);
  push ax
  mov ax,y0m
  mov bx,y0s
  mov al,ah
  mov ah,bl
  add ax,YN
  mov ym,ax
  pop ax
  }

  asm {  // y0+=sy;
  push ax
  mov ax,y0m
  add ax,sym
  mov y0m,ax
  mov ax,y0s
  adc ax,sys
  mov y0s,ax
  pop ax
  }

  asm {
  push ax
  push bx
  push cx
  push dx

  mov ax,ym
  shr ax,1
  mov ygran1,ax
  mov ax,ym
  sub ax,ygran1
  mov roznica,ax
  mov ax,ygran1
  cmp ax,yekr
  jng nic_nie_obcinaj
  sub ax,yekr
  mov obciete,ax
  mov ax,yekr
  mov ygran1,ax
  jmp ustaw_ygran2
  }
  nic_nie_obcinaj:
  asm {
  mov ax,0
  mov obciete,ax
  }
  ustaw_ygran2:
  asm {
  mov ax,ygran1
  add obciete,ax

  mov ax,ym
  add ax,roznica
  cmp ax,yekr
  jng z_dolu_tez_nie
  mov ax,yekr
  }
  z_dolu_tez_nie:
  asm {
  mov ygran2,ax

  pop dx
  pop cx
  pop bx
  pop ax
  }


  dzielnik=dzielnik0;


  if (dzielnik)
  {

    am=(unsigned)(a0/dzielnik)+PNbit;

    asm {
    push ax
    push bx
    push cx
    push dx
    push es
    push di
    push si

    mov ax,bufor_seg
    mov es,ax   // segment ekranu

     mov ax,yekr	// py=yekr-ygran;
     sub ax,ygran1

     mov cl,6
     shl ax,cl
     mov bx,ax
     shl ax,1
     add ax,bx

     add ax,xekr   // px=xm+xekr; - zapis w buforze - od (0,0)
     add ax,xm

     mov di,ax		// pozycja pierwszego pixela w petli
     add di,bufor_off


     mov bx,ym
     mov ym2,bx


     mov bx,am
     and bx,POT_SZER
     add bx,potwor_off
     mov pomoc,bx

		// for (q=-ygran;q<=ygran;q++)
    mov ax,1
    sub ax,ygran1
    mov si,ax

    }

petla_q:
    asm {
    mov ax,si
    add ax,obciete

	xor dh,dh // wyzszy bajt = 0
	mov dl,ah
	mov cl,8-pot_wys_bit
	shr dl,cl
	mov cl,pot_wys_bit
	shl ax,cl

    idiv ym2 	// bm/=y;

    // mov bm,ax   // w bm jest odpowiednik b ( mlodsze slowo )
    // to uproszczenie jest mozliwe tylko wtedy, jezeli
    // iloczyn liczby oznaczajacej pionowa rozdzielczosc ( wzor_wys )
    // i maksymalnego y ( ygran ) sa mniejsze od 32767
    // ( wartosc bezwzgledna )


    // czytanie wzoru z murku

    and ax,POT_WYS
    mov cl,POT_SZER_BIT
    shl ax,cl

    add ax,pomoc   // - dodaje wspolrzedna x i offset murku

    xchg di,ax // chwilowa wymiana rejestrow
    mov cx,es
    mov bx,potwor_seg // segment potworka
    mov es,bx

    mov dl,es:[di]
    mov di,ax
    mov es,cx

    cmp dl,0
    je nie_ma		// potwor - tylko niezerowy wzor

	//*********

    // putpixel(((int)x)+ax+xekr,yekr+q+ay,k);
    mov es:[di],dl
    }
    nie_ma:
    asm {
    add di,192

     inc si
     cmp si,ygran2
     jge koniec_q
     jmp petla_q
     }
koniec_q:
     asm {


     pop si
     pop di
     pop es
     pop dx
     pop cx
     pop bx
     pop ax
     }
  }

  if (znaksx>0)
	{ xm++; dzielnik0+=par2; a0+=WNszer; }
  else
	{ xm--; dzielnik0-=par2; a0-=WNszer; }

 }

}





#define XTERMINBIT 1
#define YTERMINBIT 0

#define ter_wys_bit 5
// bitowa wysokosc polowy ekranu
#define TER_WYS 63
#define TER_SZER 127
#define TER_SZER_BIT 7



extern unsigned ter_off,ter_seg;



void paint_terminal(void)
{
 int deltax,p,ygran,pomoc;
 long par1,par2,sy,a0,dzielnik,dzielnik0,WNszer;
 unsigned sym,sys,PNbit;
 int xm;
 unsigned am,ym,ym2,y0m,y0s;
 int znaksx;


 deltax=abs(XM-XN);

 szerokosc=abs(PM-PN);

 if (XM-XN<0) znaksx=-1; else znaksx=1;

 sy=(YM-YN); sy<<=8; sy/=deltax;

 sym=(unsigned)(sy); sys=(unsigned)(sy >> 16);

 par1=WXM-WXN; par2=WN-WM;

 PNbit=PN << XTERMINBIT;

 xm=(unsigned)(XN);

 dzielnik0=par1+xm*par2;

 a0=xm*WN-WXN; a0*=szerokosc;

 WNszer=WN*szerokosc;

 y0m=0; y0s=0;

 for (p=0;p<=deltax;p++)
  {
		// y=YN+((sy*p)>>8);

  asm {  // ym=YN+(unsigned)(y0 >> 8);
  push ax
  mov ax,y0m
  mov bx,y0s
  mov al,ah
  mov ah,bl
  add ax,YN
  mov ym,ax
  // ygran=ym;
  // if (ygran>yekr) ygran=yekr;
  cmp ax,yekr
  jng ustaw_ygran
  mov ax,yekr
  }
  ustaw_ygran:
  asm {
  mov ygran,ax
  pop ax
  }

  asm {  // y0+=sy;
  push ax
  mov ax,y0m
  add ax,sym
  mov y0m,ax
  mov ax,y0s
  adc ax,sys
  mov y0s,ax
  pop ax
  }






  dzielnik=dzielnik0 >> XTERMINBIT;


  if (dzielnik)
  {


    am=(unsigned)(a0/dzielnik)+PNbit;

    asm {
    push ax
    push bx
    push cx
    push dx
    push es
    push di
    push si

    mov ax,bufor_seg
    mov es,ax   // segment ekranu

     mov ax,yekr	// py=yekr-ygran;
     sub ax,ygran

     mov cl,6
     shl ax,cl
     mov bx,ax
     shl ax,1
     add ax,bx

     add ax,xekr   // px=xm+xekr; - zapis w buforze - od (0,0)
     add ax,xm


     mov di,ax		// pozycja pierwszego pixela w petli
     add di,bufor_off
		// for (q=-ygran;q<=ygran;q++)


     mov bx,am
     and bx,TER_SZER
     add bx,ter_off
     mov pomoc,bx

     mov bx,ym
     mov cl,YTERMINBIT
     sar bx,cl
     mov ym2,bx


    mov ax,1
    sub ax,ygran
    mov si,ax

    }

petla_q:
    asm {
    mov ax,si
    add ax,ym

	xor dh,dh
	mov dl,ah
	mov cl,8-ter_wys_bit
	shr dl,cl
	mov cl,ter_wys_bit
	shl ax,cl


    idiv ym2 	// bm/=y;

    // mov bm,ax   // w bm jest odpowiednik b ( mlodsze slowo )
    // to uproszczenie jest mozliwe tylko wtedy, jezeli
    // iloczyn liczby oznaczajacej pionowa rozdzielczosc ( wzor_wys )
    // i maksymalnego y ( ygran ) sa mniejsze od 32767
    // ( wartosc bezwzgledna )


    // czytanie wzoru z murku

    and ax,TER_WYS
    mov cl,TER_SZER_BIT	      // zakladam, ze murek ma na szerokosc 32 pkty
    shl ax,cl


    add ax,pomoc   // - dodaje wspolrzedna x i offset

    xchg di,ax // chwilowa wymiana rejestrow
    mov cx,es
    mov bx,ter_seg // segment murku
    mov es,bx

    mov dl,es:[di]
    mov di,ax
    mov es,cx

    // putpixel(((int)x)+ax+xekr,yekr+q+ay,k);
    mov es:[di],dl
    add di,192

     inc si
     cmp si,ygran
     jge koniec_q
     jmp petla_q
     }
koniec_q:
     asm {

     pop si
     pop di
     pop es
     pop dx
     pop cx
     pop bx
     pop ax
     }
  }


  if (znaksx>0)
	{ xm++; dzielnik0+=par2; a0+=WNszer; }
  else
	{ xm--; dzielnik0-=par2; a0-=WNszer; }

 }

}



#define termin 0
#define termax 64
#define wzormin 0
#define wzormax 64
#define oppmin 0
#define oppmax 32

extern punkt E;
extern wektor PE;
extern long WK,WKwys_sciany;

long WS(punkt &K)
{ return (PA.x*(E.y-K.y)-(E.x-K.x)*PA.y)>>dokbit; }

long WX(punkt &K)
{ return (PE.x*(E.y-K.y)-(E.x-K.x)*PE.y)>>dokbit; }


void scianka(punkt &N,punkt &M)
{
 punkt q;
 long KN,KM;
 int widze=3;


 WN=(PA.x*(E.y-N.y)-(E.x-N.x)*PA.y)>>dokbit;
 WM=(PA.x*(E.y-M.y)-(E.x-M.x)*PA.y)>>dokbit;

 PN=wzormin; PM=wzormax;

 if ((WM<dokladnosc) && (WM>-dokladnosc))
	widze-=1;
	else
	{
	KM=WK/WM;
	// WK ma podwojna dokladnosc
	if ((KM>dokladnosc) || (KM<0)) widze-=1;
	}

 if ((WN<dokladnosc) && (WN>-dokladnosc))
	widze-=2;
	else
	{
	KN=WK/WN;
	if ((KN>dokladnosc) || (KN<0)) widze-=2;
	}

  // jezeli tylko jeden z punktow jest widoczny - znalezienie przeciecia
  // sciany z ekranem

 if (widze==3)
  {
 WXN=(PE.x*(E.y-N.y)-(E.x-N.x)*PE.y)>>dokbit;
 WXM=(PE.x*(E.y-M.y)-(E.x-M.x)*PE.y)>>dokbit;
  }

  if (widze==2)
  {
   q=przeciecie(M,N,PM,PN-PM);
   WM=(PA.x*(E.y-q.y)-(E.x-q.x)*PA.y)>>dokbit;
   if ((WM>=dokladnosc) || (WM<=-dokladnosc))
    {
     WXN=(PE.x*(E.y-N.y)-(E.x-N.x)*PE.y)>>dokbit;
     WXM=(PE.x*(E.y-q.y)-(E.x-q.x)*PE.y)>>dokbit;
     widze=3;
    }
  }

  if (widze==1)
  {
   q=przeciecie(N,M,PN,PM-PN);
   WN=(PA.x*(E.y-q.y)-(E.x-q.x)*PA.y)>>dokbit;
   if ((WN>=dokladnosc) || (WN<=-dokladnosc))
    {
     WXN=(PE.x*(E.y-q.y)-(E.x-q.x)*PE.y)>>dokbit;
     WXM=(PE.x*(E.y-M.y)-(E.x-M.x)*PE.y)>>dokbit;
     widze=3;
    }
  }



  if (widze==3)
  {

     XN=(int)(WXN/WN); XM=(int)(WXM/WM);


   if (XN!=XM)
   {
     YN=(int)(WKwys_sciany/WN);
     YM=(int)(WKwys_sciany/WM);

	// scianki dokladnie prostopadle do ekranu sa niewidoczne

 // korekcja x-ow ktore wychodza za daleko poza ekran
 if (XN<-xekr) obetnij_z_lewej(XN,YN,XM,YM);
 else if (XN>xekr+1) obetnij_z_prawej(XN,YN,XM,YM);
 if (XM<-xekr) obetnij_z_lewej(XM,YM,XN,YN);
 else if (XM>xekr+1) obetnij_z_prawej(XM,YM,XN,YN);


  if (XN!=XM) paint_wall();
   }
  }
}





extern long WKwys_potwora;
extern unsigned glowacz1_seg,glowacz1_off,glowacz2_seg,glowacz2_off;
extern int faza;
extern int strzal,trafiony;
extern unsigned linia_strzalu;



void opponent(punkt &N,punkt &M)
{
 punkt q;
 long KN,KM;
 int widze=1;

 WN=(PA.x*(E.y-N.y)-(E.x-N.x)*PA.y)>>dokbit;
 WM=(PA.x*(E.y-M.y)-(E.x-M.x)*PA.y)>>dokbit;

 PN=oppmin; PM=oppmax;
	if (faza)
	{
	potwor_seg=glowacz2_seg; potwor_off=glowacz2_off;
	}
	else
	{
	potwor_seg=glowacz1_seg; potwor_off=glowacz1_off;
	}

 if ((WM<dokladnosc) && (WM>-dokladnosc))
	widze=0;
 else
	{
	KM=WK/WM;
	// WK ma podwojna dokladnosc
	if ((KM>dokladnosc) || (KM<0)) widze=0;
	}

 if (widze)
 {
 if ((WN<dokladnosc) && (WN>-dokladnosc))
	widze=0;
 else
	{
	KN=WK/WN;
	if ((KN>dokladnosc) || (KN<0)) widze=0;
	}
 }

  // jezeli tylko jeden z punktow jest widoczny - znalezienie przeciecia
  // sciany z ekranem

 if (widze)
  {
 WXN=(PE.x*(E.y-N.y)-(E.x-N.x)*PE.y)>>dokbit;
 WXM=(PE.x*(E.y-M.y)-(E.x-M.x)*PE.y)>>dokbit;

 XN=(int)(WXN/WN); XM=(int)(WXM/WM);


   if (XN!=XM)
   {

   YN=(int)(WKwys_potwora/WN);
   YM=(int)(WKwys_potwora/WM);

	// scianki dokladnie prostopadle do ekranu sa niewidoczne

 // korekcja x-ow ktore wychodza za daleko poza ekran
 if (XN<-xekr) obetnij_z_lewej(XN,YN,XM,YM);
 else if (XN>xekr+1) obetnij_z_prawej(XN,YN,XM,YM);
 if (XM<-xekr) obetnij_z_lewej(XM,YM,XN,YN);
 else if (XM>xekr+1) obetnij_z_prawej(XM,YM,XN,YN);

  if (XN!=XM)
	{
	paint_monster();
	asm {
	push ax
	mov ax,strzal
	and ax,1
	jz pudlo
	mov ax,XN
	cmp ax,3
	jl xm_wieksze
	mov ax,XM
	cmp ax,-3
	jge pudlo
	jmp dostal
	}
	xm_wieksze:
	asm {
	cmp ax,-3
	jg pudlo
	mov ax,XM
	cmp ax,3
	jle pudlo
	}
	dostal:
	asm {
	mov ax,1
	mov trafiony,ax

	mov ax,YN
	add ax,YM
	shr ax,1		// (YM+YN)/2
	mov linia_strzalu,ax

	}
	pudlo:
	asm {
	pop ax
	    }
	}
     }
   }
}



extern long WKwys_terminala;

void rysuj_terminal(punkt &N,punkt &M)
{
 punkt q;
 long KN,KM;
 int widze=1;

 WN=(PA.x*(E.y-N.y)-(E.x-N.x)*PA.y)>>dokbit;
 WM=(PA.x*(E.y-M.y)-(E.x-M.x)*PA.y)>>dokbit;

 PN=termin; PM=termax;

 if ((WM<dokladnosc) && (WM>-dokladnosc))
	widze=0;
 else
	{
	KM=WK/WM;
	// WK ma podwojna dokladnosc
	if ((KM>dokladnosc) || (KM<0)) widze=0;
	}

 if (widze)
 {
 if ((WN<dokladnosc) && (WN>-dokladnosc))
	widze=0;
 else
	{
	KN=WK/WN;
	if ((KN>dokladnosc) || (KN<0)) widze=0;
	}
 }


 if (widze)
  {
 WXN=(PE.x*(E.y-N.y)-(E.x-N.x)*PE.y)>>dokbit;
 WXM=(PE.x*(E.y-M.y)-(E.x-M.x)*PE.y)>>dokbit;

 XN=(int)(WXN/WN); XM=(int)(WXM/WM);


   if (XN!=XM)
   {

   YN=(int)(WKwys_terminala/WN);
   YM=(int)(WKwys_terminala/WM);

	// scianki dokladnie prostopadle do ekranu sa niewidoczne

 // korekcja x-ow ktore wychodza za daleko poza ekran
 if (XN<-xekr) obetnij_z_lewej(XN,YN,XM,YM);
 else if (XN>xekr+1) obetnij_z_prawej(XN,YN,XM,YM);
 if (XM<-xekr) obetnij_z_lewej(XM,YM,XN,YN);
 else if (XM>xekr+1) obetnij_z_prawej(XM,YM,XN,YN);

  if (XN!=XM)
	{
	paint_terminal();
	}
  }
 }
}
