


; Zoptymalizowany modul do mapowania pionowej tekstury w symulacjach
; trojwymiarowych
;			by Pawelek Biernacki

; w module zostaly wykorzystane instrukcje 386
; techniki roznicowe do optymalizacji obliczania funkcji liniowych



MODEL COMPACT

.386



MUR_WYS=31
	; maska do "and-dowania" wspolrzednej na teksturze - wysokosc wzoru-1

MUR_SZER=63
	; maska do "and-dowania" wspolrzednej na teksturze - szerokosc wz.-1

MUR_SZER_BIT=6
	; bitowy rozmiar szerokosci wzoru



wzor_wys_bit=4
	; logarytm dwojkowy z (MUR_WYS+1) pomniejszony o 1
	; ( bitowa wielkosc polowy wysokosci wzoru )

precyzja=14
	; ilosc bitow ( suma z wzor_wys_bit oraz iloscia bitow
	; na zakres licznika y i bitem znaku nie moze przekraczac 32 )
	; przeznaczona na dokladnosc przy linearyzacji wewnetrznej
	; petli ( y->b )

SHIFTED_MUR_WYS=MUR_WYS SHL MUR_SZER_BIT

GLOBAL _WN:DWORD
GLOBAL _ssy:DWORD
GLOBAL _WXN:DWORD
GLOBAL _szerokosc:WORD
GLOBAL _p:WORD
GLOBAL _deltax:WORD
GLOBAL _znaksx:WORD
GLOBAL _par1:DWORD
GLOBAL _par2:DWORD
GLOBAL _WNszer:DWORD

GLOBAL _y0m:WORD
GLOBAL _y0s:WORD
GLOBAL _YN:WORD
GLOBAL _ym:WORD
GLOBAL _yekr:WORD
GLOBAL _xekr:WORD
GLOBAL _ygran:WORD
GLOBAL _sym:WORD
GLOBAL _sys:WORD
GLOBAL _PNbit:WORD
GLOBAL _am:WORD
GLOBAL _xm:WORD
GLOBAL _ym:WORD
GLOBAL _ym2:WORD
GLOBAL _pomoc:WORD

GLOBAL _a0:DWORD
GLOBAL _dzielnik0:DWORD
GLOBAL _dzielnik:DWORD

GLOBAL _bufor_seg:WORD
GLOBAL _bufor_off:WORD
GLOBAL _murek_seg:WORD
GLOBAL _murek_off:WORD
GLOBAL _wzor_wys_anim:WORD


.DATA
shifted_wzor_wys_anim DW ?
licznik_y DD ?
delta_y DD ?


PUBLIC _podziel


.CODE


_podziel PROC

  push eax
  push edx

    push ax
    push bx
    push cx
    push dx
    push es
    push di
    push si
    push fs

    mov cl,8
    sal _ssy,cl

    mov ax,_deltax
    cwde
    mov ebx,eax
    mov eax,_ssy
    cdq
    idiv ebx
    mov _ssy,eax

    mov _sym,ax
    mov cl,16
    shr eax,cl
    mov _sys,ax


    mov ax,_xm
    cwde
    imul _par2
    add eax,_par1
    mov _dzielnik0,eax

    mov ax,_xm
    cwde
    imul _WN
    sub eax,_WXN
    mov ebx,eax
    mov ax,_szerokosc
    cwde
    imul ebx
    mov _a0,eax

    mov ax,_szerokosc
    cwde
    imul _WN
    mov _WNszer,eax

    xor ax,ax
    mov _y0m,ax
    mov _y0s,ax


  mov ax,0
  mov _p,ax

  petla_p:


  mov ax,_y0m
  mov bx,_y0s
  mov al,ah
  mov ah,bl
  add ax,_YN
  mov _ym,ax
  cmp ax,_yekr
  jng ustaw_ygran
  mov ax,_yekr
  ustaw_ygran:
  mov _ygran,ax

  mov ax,_y0m
  add ax,_sym
  mov _y0m,ax
  mov ax,_y0s
  adc ax,_sys
  mov _y0s,ax





  mov eax,_dzielnik0
  mov _dzielnik,eax


  cmp eax,0
  je nie_wchodz
  jmp wejdz
  nie_wchodz:
  jmp omin
  wejdz:

  mov eax,_a0
  cdq
  idiv _dzielnik
  add ax,_PNbit
  mov _am,ax

   ;  am=(unsigned)(a0/dzielnik)+PNbit;




    mov ax,_bufor_seg
    mov es,ax

     mov ax,_yekr
     sub ax,_ygran

     mov cl,6
     shl ax,cl
     mov bx,ax
     shl ax,1
     add ax,bx

     add ax,_xekr
     add ax,_xm


     mov di,ax
     add di,_bufor_off


     mov bx,_am
     and bx,MUR_SZER
     add bx,_murek_off
     mov _pomoc,bx

     mov bx,_ym
     mov _ym2,bx


    mov ax,1
    sub ax,_ygran
    mov si,ax


    ; liczba 16 bitowa przesunieta w lewo o wzor_wys_bit (4) bity
    ; ( w sumie 20 bitow ) - dla zwiekszenia precyzji reprezentacji
    ; mozna wykorzystac 16-wzor_wys_bit ( 12 ) bitow w liczbie 32 bitowej

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    ; w ax jest stan poczatkowy ( bez przesuniecia o wzor_wys_bit i
    ; przesuniecia o bity precyzji )


    add ax,_ym ; poprawka ( jak w petli )

    cwde 	; rozszerzenie ax na 32 bitowe slowo

    mov cl,wzor_wys_bit+precyzja
    shl eax,cl	; przesuniecie w lewo o wzor_wys_bit

    mov edx,eax ; przechowanie w edx

    mov ax,_ym2 ; przygotowanie dzielnika
    cwde	; rozszerzenie na 32 bity
    mov ebx,eax ; przeslanie dzielnika do ebx

    mov eax,edx ; odebranie z powrotem dzielnej z edx
    cdq		; rozszerzenie na 64 bity ( edx:eax )

    idiv ebx	; dzielenie przez _ym2 ( przeskalowanie )

    mov licznik_y,eax
		; ustawienie stanu poczatkowego licznika
		; w 10-cio bitowej precyzji

    ; trzeba obliczyc jeszcze roznice i zapisac ja w reprezentacji
    ; 10-cio bitowej precyzji

    ; si jest w kazdym przebiegu zwiekszane o 1 :

    mov eax,1

    mov cl,wzor_wys_bit+precyzja
    shl eax,cl	; przesuniecie w lewo o wzor_wys_bit

    cdq		; rozszerzenie na 64 bity ( edx:eax )
    idiv ebx	; dzielenie przez _ym2 ( przeskalowanie )

    mov delta_y,eax
		; ustawienie roznicyw 10-cio bitowej precyzji


    mov bx,_murek_seg
    mov fs,bx

    mov edx,delta_y
		; rezerwacja edx na czas pracy malej petli

    mov ax,_wzor_wys_anim
    mov cl,MUR_SZER_BIT
    shl ax,cl
    add ax,_pomoc
    mov shifted_wzor_wys_anim,ax


    mov cl,precyzja-MUR_SZER_BIT
		; rezerwacja cl na czas pracy malej petli

    mov bx,shifted_wzor_wys_anim
		; rezerwacja bx

    mov ax,si

petla_q:


    ; poniewaz _ym2 jest stale - obliczane wyrazenie zalezy od licznika
    ; petli w sposob liniowy - mozna uniknac dzielenia !!!

    mov esi,licznik_y
    shr esi,cl
    and si,SHIFTED_MUR_WYS

    add licznik_y,edx
	; zmiana stanu licznika ( liniowa )

    mov ch,fs:[si+bx]	; sciagniecie wzoru z tekstury
    mov es:[di],ch	; narysowanie punktu na ekranie
    add di,192

    inc ax
    cmp ax,_ygran
    jl petla_q
			;;; zakonczenie wewnetrznej petli

     koniec_q:

     omin:


     mov ax,_znaksx
     cmp ax,0
     jle ujemny

     inc _xm
     mov eax,_dzielnik0
     add eax,_par2
     mov _dzielnik0,eax
     mov eax,_a0
     add eax,_WNszer
     mov _a0,eax

     jmp koniec
     ujemny:


     dec _xm
     mov eax,_dzielnik0
     sub eax,_par2
     mov _dzielnik0,eax
     mov eax,_a0
     sub eax,_WNszer
     mov _a0,eax

     koniec:

     inc _p
     mov ax,_p
     cmp ax,_deltax
     jg koniec_p
     jmp petla_p

     koniec_p:

     pop fs
     pop si
     pop di
     pop es
     pop dx
     pop cx
     pop bx
     pop ax


  pop edx
  pop eax

  ret
_podziel ENDP

END